Summary: Tools for managing dns zone files
Name: ndu
Version: 0.4
Release: 7%{?dist:%{dist}}
license: GPL
Group: System Environment/Daemons
Source: http://uranus.it.swin.edu.au/~jn/linux/ndu-%{version}.tar.gz
URL: http://uranus.it.swin.edu.au/~jn/linux/dns.htm
Packager: John Newbign (jn@it.swin.edu.au)
BuildRoot: /var/tmp/%{name}-buildroot
Distribution: Preminition
Vendor: Preminition Software
Requires: ed
Requires: bind
Requires: /bin/sh

%description
dnstouch is like touch but it updates zone file serial numbers
ndu automaticly rebuilds reverse zone file based on forward zone files
dnsedit is a small script which combines the above tasks

%prep
%setup
if [ %{version} != `cat src/version` ] ; then
   echo "RPM spec version does not match source code version"
fi

%build
cd src
make

%install
cd src
make install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/sbin
install -m 755 dnstouch $RPM_BUILD_ROOT/usr/sbin/dnstouch
install -m 755 ndu $RPM_BUILD_ROOT/usr/sbin/ndu
install -m 755 dnsedit $RPM_BUILD_ROOT/usr/sbin/dnsedit

mkdir -p $RPM_BUILD_ROOT/etc
install -m 644 ../ndu.conf $RPM_BUILD_ROOT/etc/ndu.conf

cd ../doc
for m in 5 8 ; do
   mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man$m
   cp *.$m $RPM_BUILD_ROOT/%{_mandir}/man$m
done

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README
%doc INSTALL
%config /etc/ndu.conf
/usr/sbin/dnstouch
/usr/sbin/ndu
/usr/sbin/dnsedit
%{_mandir}/man*/*

%post
if [ "$1" = 1 ] ; then # install
   if [ -f /etc/sysconfig/named ] ; then
     . /etc/sysconfig/named
	 if [ "$ROOTDIR" ] ; then
	    echo "chroot \"$ROOTDIR\"" >> /etc/ndu.conf
	 fi
	 if [ -f /var/named/named.local ] ; then
        echo "ignore localhost.localdomain" >> /etc/ndu.conf
	 fi
   fi
fi


%changelog
* Sat Jul 23 2005 John Newbigin <jn@it.swin.edu.au>
- Support for RHEL4
- Added man pages
* Mon Nov 03 2003 John Newbigin <jn@it.swin.edu.au>
- Update dnsedit script to be secure and use vim
* Tue Apr 09 2001 John Newbigin <jn@it.swin.edu.au>
- Add build script
- Works with new bind9 config
- Added Distribution and Vendor
* Thu Feb 08 2001 John Newbigin <jn@it.swin.edu.au>
- Update to version 0.4
- Supports chroot bind
- Allows non a..z characters in zone files
* Mon Feb 05 2001 John Newbigin <jn@it.swin.edu.au>
- Update to version 0.3
- Added requires
* Fri Feb 02 2001 John Newbigin <jn@it.swin.edu.au>
- First attempt at spec file
